Subject: bug#66339: [PATCH gnome-team v6] gnu: dbus-service: make the session available under /run/dbus

From: Liliana Marie Prikler <[email-masked]>
Date: Sun, 08 Oct 2023 16:53:23 +0200

Am Mittwoch, dem 04.10.2023 um 12:47 +0200 schrieb Vivien Kraus:
> According to
> https://gitlab.gnome.org/GNOME/glib/-/merge_requests/3101, glib
> now searches for the session bus socket in runstatedir. The dbus
> service must thus have its socket in /run/dbus.
> 
> For interoperability with the dbus standard, /run/dbus is also
> symlinked to
> /var/run/dbus.
> 
> * gnu/services/dbus.scm (dbus-activation): Symlink /run/dbus to
> /var/run/dbus.
> (%dbus-accounts): Run dbus in /run/dbus.
> (dbus-root-service-type): Save the pid file in /run/dbus.
> ---
> 
> Hello,
> 
> I changed my mind back to a previous mind change, so: the socket
> should be
> installed in /run.  I believe that the code moves the content of the
> existing
> /var/run/dbus to /run/dbus before trying the symlink again, if
> /var/run/dbus
> exists and is not a symlink to /run/dbus.  I don’t really have a way
> to check
> the interesting case where existing files need to be moved.  However,
> the
> gnome-team-configured VM works.
> 
> Best regards,
> 
> Vivien
> 
>  gnu/services/dbus.scm | 39 ++++++++++++++++++++++++++++++++++++---
>  1 file changed, 36 insertions(+), 3 deletions(-)
> 
> diff --git a/gnu/services/dbus.scm b/gnu/services/dbus.scm
> index 5a0c634393..aa9ce0720c 100644
> --- a/gnu/services/dbus.scm
> +++ b/gnu/services/dbus.scm
> @@ -163,7 +163,7 @@ (define %dbus-accounts
>           (group "messagebus")
>           (system? #t)
>           (comment "D-Bus system bus user")
> -         (home-directory "/var/run/dbus")
> +         (home-directory "/run/dbus")
>           (shell (file-append shadow "/sbin/nologin")))))
>  
>  (define dbus-setuid-programs
> @@ -186,7 +186,40 @@ (define (dbus-activation config)
>          (let ((user (getpwnam "messagebus")))
>            ;; This directory contains the daemon's socket so it must
> be
>            ;; world-readable.
> -          (mkdir-p/perms "/var/run/dbus" user #o755))
> +          (mkdir-p/perms "/run/dbus" user #o755))
> +
> +        (catch 'system-error
> +          (lambda ()
> +            (symlink "/run/dbus" "/var/run/dbus"))
> +          (lambda args
> +            (let ((errno (system-error-errno args)))
> +              (cond
> +               ((= errno EEXIST)
> +                (let ((existing-name
> +                       (false-if-exception
> +                        (readlink "/var/run/dbus"))))
> +                  (unless (equal? existing-name "/run/dbus")
> +                    ;; Move the content of /var/run/dbus to
> /run/dbus, and
> +                    ;; retry.
> +                    (let ((dir (opendir "/var/run/dbus")))
> +                      (let move-to-/run/dbus ((next (readdir dir)))
> +                        (cond
> +                         ((eof-object? next)
> +                          (closedir dir))
> +                         ((member next '("." ".."))
> +                          (move-to-/run/dbus (readdir dir)))
> +                         (else
> +                          (begin
> +                            (rename-file (string-append
> "/var/run/dbus/" next)
> +                                         (string-append "/run/dbus/"
> next))
> +                            (move-to-/run/dbus (readdir dir))))))))
I'd rename "move-to-/run/dbus" to the boring but more idiomatic "loop".
This saves us some horizontal real-estate that'd allow us to squash
some lines.
> +                      (rmdir "/var/run/dbus")
> +                      (symlink "/run/dbus" "/var/run/dbus")))
> +               (else
> +                (format (current-error-port)
> +                        "Failed to symlink /run/dbus to
> /var/run/dbus: ~s~%"
> +                        (strerror errno))
> +                (error "cannot create /var/run/dbus"))))))
>  
>          (unless (file-exists? "/etc/machine-id")
>            (format #t "creating /etc/machine-id...~%")
> @@ -210,7 +243,7 @@ (define dbus-shepherd-service
>                               '(#:environment-variables
> '("DBUS_VERBOSE=1")
>                                 #:log-file "/var/log/dbus-
> daemon.log")
>                               '())
> -                      #:pid-file "/var/run/dbus/pid"))
> +                      #:pid-file "/run/dbus/pid"))
>              (stop #~(make-kill-destructor)))))))
>  
>  (define dbus-root-service-type
> 
> base-commit: b18b2d13488f2a92331ccad2dc8cbb54ee15582f
Otherwise LGTM.  I'd commit it, but my machine is currently busy
building half of core-updates for no reason.

Cheers